﻿using System;
using System.Drawing;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading;
using System.Collections;
using System.Runtime.InteropServices;
using System.Diagnostics;


namespace EPT_Tel_D_Emulator
{
    public partial class EPT_Tel_D_Emulator
    {

        t_TelDcommand [] TelDcommand = new t_TelDcommand[22];

        public enum TELDcommandEnum
        {
            TELD_COMMAND_INITIALIZE,
            TELD_COMMAND_SCAN_NETWORK,
            TELD_COMMAND_JOIN_NETWORK,
            TELD_COMMAND_LEAVE_NETWORK,
            TELD_COMMAND_TRANSMIT_PACKET,
            TELD_COMMAND_READ_DATA,
            TELD_COMMAND_READ_STATUS,
            TELD_COMMAND_READ_NETWORK_STATUS,
            TELD_COMMAND_READ_REVISION,
            TELD_COMMAND_SET_INTERRUPT_FLAGS,
            TELD_COMMAND_NETWORK_MAC_IDS,
            TELD_COMMAND_SET_SECURITY_MODE,
            TELD_COMMAND_READ_STATISTICS,
            TELD_COMMAND_SET_RF_MODE,
            TELD_COMMAND_SET_RF_PARAMETERS,
            TELD_COMMAND_CLEAR_STATUS,
            TELD_COMMAND_PURGE_PACKET,
            TELD_COMMAND_READ_RF_PARAMETERS,
            TELD_COMMAND_WRITE_UPGRADE_PACKET,
            TELD_COMMAND_SET_LINK_KEY,
            TELD_COMMAND_SET_CCA_THRESHOLD,

            //
            //    Maximum TelD Command value
            //
            TELD_COMMAND_MAX

        }
        public void InitTelDCommandArray()
        {
            TelDcommand[0].eTelDcommand     = 0x00;
            TelDcommand[0].byAckValue       = 0x00;
            TelDcommand[0].byRxLength       = 0x00;
            TelDcommand[0].byAckRsn         = 0x00;
            TelDcommand[0].byStatus         = 0x00;
            TelDcommand[0].byCRC1           = 0x00;
            TelDcommand[0].byCRC2           = 0x1a;

            TelDcommand[1].eTelDcommand     = 0x01;
            TelDcommand[1].byAckValue       = 0x55;
            TelDcommand[1].byRxLength       = 0x04;
            TelDcommand[1].byAckRsn         = 0x00;
            TelDcommand[1].byStatus         = 0x00;
            TelDcommand[1].byCRC1           = 0x32;
            TelDcommand[1].byCRC2           = 0x1a;

            TelDcommand[2].eTelDcommand     = 0x02;
            TelDcommand[2].byAckValue       = 0x55;
            TelDcommand[2].byRxLength       = 0x10;
            TelDcommand[2].byAckRsn         = 0x00;
            TelDcommand[2].byStatus         = 0x00;
            TelDcommand[2].byCRC1           = 0x32;
            TelDcommand[2].byCRC2           = 0x1a;

            TelDcommand[3].eTelDcommand     = 0x03;
            TelDcommand[3].byAckValue       = 0x55;
            TelDcommand[3].byRxLength       = 0x1C;
            TelDcommand[3].byAckRsn         = 0x00;
            TelDcommand[3].byStatus         = 0x00;
            TelDcommand[3].byCRC1           = 0x32;
            TelDcommand[3].byCRC2           = 0x1a;

            TelDcommand[4].eTelDcommand     = 0x04;
            TelDcommand[4].byAckValue       = 0x55;
            TelDcommand[4].byRxLength       = 0xFF;
            TelDcommand[4].byAckRsn         = 0x00;
            TelDcommand[4].byStatus         = 0x00;
            TelDcommand[4].byCRC1           = 0x32;
            TelDcommand[4].byCRC2           = 0x1a;

            TelDcommand[5].eTelDcommand     = 0x05;
            TelDcommand[5].byAckValue       = 0x55;
            TelDcommand[5].byRxLength       = 0xFF;
            TelDcommand[5].byAckRsn         = 0x00;
            TelDcommand[5].byStatus         = 0x00;
            TelDcommand[5].byCRC1           = 0x32;
            TelDcommand[5].byCRC2           = 0x1a;

            TelDcommand[6].eTelDcommand     = 0x06;
            TelDcommand[6].byAckValue       = 0x55;
            TelDcommand[6].byRxLength       = 0x02;
            TelDcommand[6].byAckRsn         = 0x00;
            TelDcommand[6].byStatus         = 0x00;
            TelDcommand[6].byCRC1           = 0x32;
            TelDcommand[6].byCRC2           = 0x1a;

            TelDcommand[7].eTelDcommand     = 0x07;
            TelDcommand[7].byAckValue       = 0x55;
            TelDcommand[7].byRxLength       = 0x02;
            TelDcommand[7].byAckRsn         = 0x00;
            TelDcommand[7].byStatus         = 0x00;
            TelDcommand[7].byCRC1           = 0x32;
            TelDcommand[7].byCRC2           = 0x1a;

            TelDcommand[8].eTelDcommand     = 0x08;
            TelDcommand[8].byAckValue       = 0x55;
            TelDcommand[8].byRxLength       = 0x03;
            TelDcommand[8].byAckRsn         = 0x00;
            TelDcommand[8].byStatus         = 0x00;
            TelDcommand[8].byCRC1           = 0x32;
            TelDcommand[8].byCRC2           = 0x1a;

            TelDcommand[9].eTelDcommand     = 0x09;
            TelDcommand[9].byAckValue       = 0x55;
            TelDcommand[9].byRxLength       = 0x02;
            TelDcommand[9].byAckRsn         = 0x00;
            TelDcommand[9].byStatus         = 0x00;
            TelDcommand[9].byCRC1           = 0x32;
            TelDcommand[9].byCRC2           = 0x1a;

            TelDcommand[10].eTelDcommand     = 0x0A;
            TelDcommand[10].byAckValue       = 0x55;
            TelDcommand[10].byRxLength       = 0x04;
            TelDcommand[10].byAckRsn         = 0x00;
            TelDcommand[10].byStatus         = 0x00;
            TelDcommand[10].byCRC1           = 0x32;
            TelDcommand[10].byCRC2           = 0x1a;

            TelDcommand[11].eTelDcommand    = 0x0B;
            TelDcommand[11].byAckValue      = 0x55;
            TelDcommand[11].byRxLength      = 0xFF;
            TelDcommand[11].byAckRsn        = 0x00;
            TelDcommand[11].byStatus        = 0x00;
            TelDcommand[11].byCRC1          = 0x32;
            TelDcommand[11].byCRC2          = 0x1a;
        
        }

/*
  //    TELD Command                    Command Value   CRC Index       Total Length
  TelDcommand[0]  = 
  { TELD_COMMAND_INITIALIZE,            0x01,           0x02,           0x0B };
  { TELD_COMMAND_SCAN_NETWORK,          0x02,           0x10,           0x19 }, // Page 18
  { TELD_COMMAND_JOIN_NETWORK,          0x03,           0x1C,           0x25 }, // Page 24
  { TELD_COMMAND_LEAVE_NETWORK,         0x04,           0xFF,           0xFF },
  { TELD_COMMAND_TRANSMIT_PACKET,       0x05,           0xFF,           0xFF }, // Page 31
  { TELD_COMMAND_READ_DATA,             0x06,           0x02,           0xFF }, // Page 33
  { TELD_COMMAND_READ_STATUS,           0x07,           0x02,           0x18 }, // Page 34
  { TELD_COMMAND_READ_NETWORK_STATUS,   0x08,           0x03,           0xB0 }, // Page 37
  { TELD_COMMAND_READ_REVISION,         0x09,           0x02,           0x17 }, // Page 38
  { TELD_COMMAND_SET_INTERRUPT_FLAGS,   0x0A,           0x04,           0x0D }, // Page ???????
  { TELD_COMMAND_NETWORK_MAC_IDS,       0x0B,           0xFF,           0xFF },
  { TELD_COMMAND_SET_SECURITY_MODE,     0x0C,           0x13,           0x1C },
  { TELD_COMMAND_READ_STATISTICS,       0x0D,           0x02,           0x53 }, // Page 43
  { TELD_COMMAND_SET_RF_MODE,           0x0E,           0x0B,           0x14 }, // Page 45
  { TELD_COMMAND_SET_RF_PARAMETERS,     0x0F,           0x0C,           0x15 }, // Page 47
  { TELD_COMMAND_CLEAR_STATUS,          0x10,           0x06,           0x15 }, // Page 48
  { TELD_COMMAND_PURGE_PACKET,          0x11,           0xFF,           0xFF },
  { TELD_COMMAND_READ_RF_PARAMETERS,    0x12,           0x02,           0x15 }, // Page 51
  { TELD_COMMAND_WRITE_UPGRADE_PACKET,  0x13,           0xFF,           0xFF },
  { TELD_COMMAND_SET_LINK_KEY,          0x14,           0xFF,           0xFF },
  { TELD_COMMAND_SET_CCA_THRESHOLD,     0x15,           0xFF,           0xFF },
  { TELD_COMMAND_MAX,                   0xFF,           0xFF,           0xFF },
};
 * 
 * */

    }

public class t_TelDcommand
{
    public byte eTelDcommand;
    public byte byAckValue;
    public byte byRxLength;
    public byte byAckRsn;
    public byte byStatus;
    public byte[] Payload;
    public byte byCRC1;
    public byte byCRC2;

  public t_TelDcommand()
        {
            eTelDcommand = 0;
            byAckValue = 0;
            byRxLength = 0;
            byAckRsn = 0;
            byStatus = 0;
            byCRC1 = 0;
            byCRC2 = 0;
        }

  
} 



}
