/*******************************************************************************
 * Filename:    DEVICEZIGBprivate.h
 *
 * Created:     April 27, 2013
 *
 * Author:      William C. Hayes
 *
 * Revision History
 *         Date         Author  Comment
 *      2013_04_27      WCH     Initial Version
 *
*******************************************************************************/

#ifndef KF_DEVICEZIGB_PRIVATE_H_
#define KF_DEVICEZIGB_PRIVATE_H_

#define DEVICE_ZIGB_QUEUE_SIZE   4

typedef enum
{
  DEVICE_ZIGB_MESSAGE_INITIALIZE_TASK,
  DEVICE_ZIGB_MESSAGE_EXTERNAL_REQUEST,
  DEVICE_ZIGB_MESSAGE_TRANSPORT_RESPONSE,
  
  //
  //    Put all other entries above this line
  //
  DEVICE_ZIGB_MESSAGE_MAX
  
} DeviceZIGBtaskMessagesEnum;


typedef struct t_Sequence
{
  UINT16        usReceiveMessageID;
  UINT16        usTransmitMessageID;
  UINT16        uiTransmitActionMessageID;
  
} DeviceZIGBsequence;


typedef struct t_DeviceZIGBdata
{
  //
  //
  //
  SessionResponseCoordinatorTypeEnum    eSessionConnectionType;
  DeviceZIGBsequence                   *psCurrentSequence;
  UINT32                                uiCurrentSequenceIndex;
  
  //
  //    Response configuration elements
  //
  TX_QUEUE                             *pqResponseMessageQueue;
  ZF_U32                                uiResponseMessageID;
  
  
} DeviceZIGBdata;

extern DeviceZIGBdata        sDeviceZIGBdata;

#endif /* KF_DEVICEZIGB_PRIVATE_H_ */
