/*******************************************************************************
 * Filename:    DeviceZIGBpublic.h
 *
 * Created:     May 25, 2013
 *
 * Author:      Richard Jolly
 *
 * Revision History
 *         Date         Author  Comment
 *      2013_05_25      WCH     Initial Version
 *
*******************************************************************************/

#ifndef KF_DEVICE_ZIGB_TASK_H_
#define KF_DEVICE_ZIGB_TASK_H_


/*******************************************************************************
**
**      Public Interface for next layer up
**
*******************************************************************************/
typedef enum
{
  SESSION_REQUEST_BASE = ZF_TASK_MESSAGE_BASE_DEVICE_ZIGB + 0x00001000,
  SESSION_REQUEST_CONFIG,
  SESSION_REQUEST_CONTROL,

  //
  //    Put all other entries above this line
  //
  SESSION_REQUEST_MAX
  
} SessionRequestEnum;

typedef enum
{
  SESSION_REQUEST_CONFIG_BASE = SESSION_REQUEST_BASE + 0x00000100,
  SESSION_REQUEST_CONFIG_SET_RESPONSE,
  SESSION_REQUEST_CONFIG_SET_SERIAL_NUMBER,
  SESSION_REQUEST_CONFIG_SET_MAC_ADDRESS,
  
  //
  //    Put all other entries above this line
  //
  SESSION_REQUEST_CONFIG_MAX
    
} SessionRequestConfigEnum;

typedef enum
{
  SESSION_REQUEST_CONTROL_BASE = SESSION_REQUEST_BASE + 0x00000200,
  SESSION_REQUEST_CONTROL_START,
  SESSION_REQUEST_CONTROL_CONNECT,
  SESSION_REQUEST_CONTROL_DISCONNECT,
  
  //
  //    Put all other entries above this line
  //
  SESSION_REQUEST_CONTROL_MAX
    
} SessionRequestControlEnum;

typedef enum
{
  SESSION_REQUEST_DATA_BASE = SESSION_REQUEST_BASE + 0x00000300,
  
  //
  //    Put all other entries above this line
  //
  SESSION_REQUEST_DATA_MAX
    
} SessionRequestDataEnum;


/*******************************************************************************
**
**      Session Response Enums
**
*******************************************************************************/
typedef enum
{
  SESSION_RESPONSE_BASE = ZF_TASK_MESSAGE_BASE_DEVICE_ZIGB + 0x00001800,
  SESSION_RESPONSE_CONFIG,
  SESSION_RESPONSE_CONTROL,
  SESSION_RESPONSE_DATA,
  
  //
  //    Put all other entries above this line
  //
  SESSION_RESPONSE_MAX
  
} SessionResponseEnum;


typedef enum
{
  SESSION_RESPONSE_STATUS_BASE = SESSION_RESPONSE_BASE + 0x00000100,
  SESSION_RESPONSE_STATUS_OK,
  SESSION_RESPONSE_STATUS_FAILED,
  
  //
  //    Put all other messages above this line
  //
  SESSION_RESPONSE_STATUS_MAX
  
} SessionResponseStatusEnum;

typedef enum
{
  SESSION_RESPONSE_CONFIG_BASE = SESSION_RESPONSE_BASE + 0x00000200,
  SESSION_RESPONSE_CONFIG_COORDINATOR_TYPE,
  
  //
  //    Put all other messages above this line
  //
  SESSION_RESPONSE_CONFIG_MAX
  
} SessionResponseConfigEnum;

typedef enum
{
  SESSION_RESPONSE_CONTROL_BASE = SESSION_RESPONSE_BASE + 0x00000300,
  SESSION_RESPONSE_CONTROL_LINK_INIT,
  SESSION_RESPONSE_CONTROL_LINK_INIT_COMPLETE,
  SESSION_RESPONSE_CONTROL_READY_TO_CONNECT,
  SESSION_RESPONSE_CONTROL_STAGE1_CONNECT,
  SESSION_RESPONSE_CONTROL_STAGE2_CONNECT,
  SESSION_RESPONSE_CONTROL_STAGE3_CONNECT,
  SESSION_RESPONSE_CONTROL_ACTIVE,
  SESSION_RESPONSE_CONTROL_INACTIVE,
  
  //
  //    Put all other entries above this line
  //
  SESSION_RESPONSE_CONTROL_MAX
  
} SessionResponseControlEnum;

typedef enum
{
  SESSION_RESPONSE_DATA_BASE = SESSION_RESPONSE_BASE + 0x00000400,
  
  //
  //    Put all other entries above this line
  //
  SESSION_RESPONSE_DATA_MAX
  
} SessionResponseDataEnum;

typedef enum
{
  SESSION_RESPONSE_COORDINATOR_TYPE_BASE = SESSION_RESPONSE_BASE + 0x00000500,
  SESSION_RESPONSE_COORDINATOR_TYPE_PDD,
  SESSION_RESPONSE_COORDINATOR_TYPE_NGP,
  SESSION_RESPONSE_COORDINATOR_TYPE_GST,
  SESSION_RESPONSE_COORDINATOR_TYPE_UNKNOWN,
  
  //
  //    Put all other entries above this line
  //
  SESSION_COORDINATOR_TYPE_MAX
    
} SessionResponseCoordinatorTypeEnum;


/*******************************************************************************
**
**      The only function interface to upper layer
**
*******************************************************************************/
void vSendToSessionTask( SessionRequestEnum eRequest, ZF_U32 uiP1, ZF_U32 uiP2, ZF_U32 uiP3, ZF_U32 uiP4 );


#endif /* KF_DEVICE_ZIGB_TASK_H_ */
