/*******************************************************************************
 * Filename:    TI2430Interface.h
 *
 * Created:     April 25, 2013
 *
 * Author:      Richard Jolly
 *
 * Revision History
 *         Date         Author  Comment
 *      2013_04_25      WCH     Initial Version
 *
*******************************************************************************/

#ifndef TI2430_INTERFACE_PRIVATE_H_
#define TI2430_INTERFACE_PRIVATE_H_

// Keep macros for speed if I want to; can be irritating
//
//
#define ZFM_TI2430_DELAY_USEC(x)         (vDelay(x))

  
#define ZFM_TI2430_RFRESET_LO            (P1OUT &= ~(0x80))
#define ZFM_TI2430_RFRESET_HI            (P1OUT |= 0x80)

#define ZFM_TI2430_RFCS_LO               (P5OUT &= ~(0x01))
#define ZFM_TI2430_RFCS_HI               (P5OUT |= 0x01)

#define ZFM_TI2430_WAIT_RFRDY_LO(x)      { while( !x ); x = 0; }

   
#define ZFM_RFRDY                        ((P1IN & 0x40) >> 6)
#define ZFM_RFINT                        ((P1IN & 0x20) >> 5)

#endif /* TI2430_INTERFACE_PRIVATE_H_ */