/*******************************************************************************
 * Filename:    ZIGBpublic.h
 *
 * Created:     May 06, 2013
 *
 * Author:      Ricahrd Jolly
 *
 * Revision History
 *         Date         Author  Comment
 *      2013_05_06      WCH     Initial Version
 *
*******************************************************************************/

#ifndef ZFM_ZIGB_PUBLIC_H_
#define ZFM_ZIGB_PUBLIC_H_


/*******************************************************************************
**
**      Public Interface for next layer up
**
*******************************************************************************/
#define ZFM_TASK_MESSAGE_BASE_ZIGB              0x00

typedef enum
{
  NETWORK_REQUEST_BASE = ZFM_TASK_MESSAGE_BASE_ZIGB + 0x00001000,
  NETWORK_REQUEST_CONFIG,
  NETWORK_REQUEST_CONTROL,
  NETWORK_REQUEST_DATA,

  //
  //    Put all other entries above this line
  //
  NETWORK_REQUEST_MAX
  
} NetworkRequestEnum;

typedef enum
{
  NETWORK_REQUEST_CONFIG_BASE = NETWORK_REQUEST_BASE + 0x00000100,
  NETWORK_REQUEST_CONFIG_SET_RESPONSE,
  NETWORK_REQUEST_CONFIG_SET_SERIAL_NUMBER,
  NETWORK_REQUEST_CONFIG_SET_MAC_ADDRESS,
  NETWORK_REQUEST_CONFIG_SET_SERIAL_NUMBER_PSC,
  NETWORK_REQUEST_CONFIG_SET_MAC_ADDRESS_PSC,
  NETWORK_REQUEST_CONFIG_SET_SERIAL_NUMBER_BGP,
  NETWORK_REQUEST_CONFIG_SET_MAC_ADDRESS_BGP,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_REQUEST_CONFIG_MAX
    
} NetworkRequestConfigEnum;

typedef enum
{
  NETWORK_REQUEST_CONTROL_BASE = NETWORK_REQUEST_BASE + 0x00000200,
  NETWORK_REQUEST_CONTROL_START,
  NETWORK_REQUEST_CONTROL_CONNECT,
  NETWORK_REQUEST_CONTROL_DISCONNECT,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_REQUEST_CONTROL_MAX
    
} NetworkRequestControlEnum;

typedef enum
{
  NETWORK_REQUEST_DATA_BASE = NETWORK_REQUEST_BASE + 0x00000300,
  NETWORK_REQUEST_DATA_TX_DATA,
  NETWORK_REQUEST_DATA_RX_DATA_ACK,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_REQUEST_DATA_MAX
    
} NetworkRequestDataEnum;


/*******************************************************************************
**
**      Network Response Enums
**
*******************************************************************************/
typedef enum
{
  NETWORK_RESPONSE_BASE = ZFM_TASK_MESSAGE_BASE_ZIGB + 0x00001800,
  NETWORK_RESPONSE_CONFIG,
  NETWORK_RESPONSE_CONTROL,
  NETWORK_RESPONSE_DATA,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_RESPONSE_MAX
  
} NetworkResponseEnum;


typedef enum
{
  NETWORK_RESPONSE_STATUS_BASE = NETWORK_RESPONSE_BASE + 0x00000100,
  NETWORK_RESPONSE_STATUS_OK,
  NETWORK_RESPONSE_STATUS_FAILED,
  NETWORK_RESPONSE_STATUS_NETWORK_TABLE_BAD,
  NETWORK_RESPONSE_STATUS_TIMER_EXPIRED,
  NETWORK_RESPONSE_STATUS_NOT_CONNECTED,
  NETWORK_RESPONSE_STATUS_NO_BUFFERS,
  
  //
  //    Put all other messages above this line
  //
  NETWORK_RESPONSE_STATUS_MAX
  
} NetworkResponseStatusEnum;

typedef enum
{
  NETWORK_RESPONSE_CONFIG_BASE = NETWORK_RESPONSE_BASE + 0x00000200,
  NETWORK_RESPONSE_CONFIG_COORDINATOR_TYPE,
  NETWORK_RESPONSE_CONFIG_COORDINATOR_MAC_ADDRESS,
  NETWORK_RESPONSE_CONFIG_COORDINATOR_SERIAL_NUMBER,
  NETWORK_RESPONSE_CONFIG_ENDNODE_MAC_ADDRESS,
  NETWORK_RESPONSE_CONFIG_ENDNODE_SERIAL_NUMBER,
  NETWORK_RESPONSE_CONFIG_ENDNODE_TELD_VERSION,
  
  //
  //    Put all other messages above this line
  //
  NETWORK_RESPONSE_CONFIG_MAX
  
} NetworkResponseConfigEnum;

typedef enum
{
  NETWORK_RESPONSE_CONTROL_BASE = NETWORK_RESPONSE_BASE + 0x00000300,
  NETWORK_RESPONSE_CONTROL_LINK_INIT,
  NETWORK_RESPONSE_CONTROL_LINK_INIT_COMPLETE,
  NETWORK_RESPONSE_CONTROL_READY_TO_CONNECT,
  NETWORK_RESPONSE_CONTROL_STAGE1_CONNECT,
  NETWORK_RESPONSE_CONTROL_STAGE2_CONNECT,
  NETWORK_RESPONSE_CONTROL_ACTIVE,
  NETWORK_RESPONSE_CONTROL_INACTIVE,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_RESPONSE_CONTROL_MAX
  
} NetworkResponseControlEnum;

typedef enum
{
  NETWORK_RESPONSE_DATA_BASE = NETWORK_RESPONSE_BASE + 0x00000400,
  NETWORK_RESPONSE_DATA_RX_DATA_AVAILABLE,
  NETWORK_RESPONSE_DATA_TX_MESSAGE_STATUS,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_RESPONSE_DATA_MAX
  
} NetworkResponseDataEnum;

typedef enum
{
  NETWORK_COORDINATOR_TYPE_BASE = NETWORK_RESPONSE_BASE + 0x00000500,
  NETWORK_COORDINATOR_TYPE_PDD,
  NETWORK_COORDINATOR_TYPE_NGP,
  NETWORK_COORDINATOR_TYPE_GST,
  NETWORK_COORDINATOR_TYPE_UNKNOWN,
  
  //
  //    Put all other entries above this line
  //
  NETWORK_COORDINATOR_TYPE_MAX
    
} NetworkCoordinatorTypeEnum;


/*******************************************************************************
**
**      The only function interface to upper layer
**
*******************************************************************************/
void vSendToNetworkTask( NetworkRequestEnum eRequest, ZFM_U32 uiP1, ZFM_U32 uiP2, ZFM_U32 uiP3, ZFM_U32 uiP4, ZFM_U32 uiP5, ZFM_U32 uiP6 );


/*******************************************************************************
**
** Other prototypes
**
*******************************************************************************/
void vZIGBsendRfInterruptReceived( void );

#endif /* ZFM_ZIGB_PUBLIC_H_ */
