/*******************************************************************************
 * Filename:    defines.h
 *
 * Created:     April 25, 2013
 *
 * Author:      Richard Jolly
 *
 * Revision History
 *         Date         Author  Comment
 *      2013_04_25      WCH     Initial Version
 *
*******************************************************************************/

#ifndef ZFM_DEFINES_H_
#define ZFM_DEFINES_H_

#define ZFM_TRUE                 (1)
#define ZFM_FALSE                (0)
#define ZFM_FOREVER              while ( 1 )
#define ZFM_FRAME_BUFFER_SIZE    2400
#define ZFM_CRC16_INIT_VAL       0xFFFF


//
//
//
#define ZFM_STACK                        char
#define ZFM_DEFAULT_STACK_SIZE           512
#define ZFM_DEFAULT_QUEUE_ELEMENT_SIZE   TX_8_ULONG

//
//  Port A Masks
//
#define ZFM_PORTA_BUTTON_SELECT          (0x01000000)
#define ZFM_PORTA_BUTTON_UP              (0x02000000)
#define ZFM_PORTA_BUTTON_HOME            (0x04000000)
#define ZFM_PORTA_BUTTON_DOWN            (0x08000000)

#define ZFM_PORTA_RFRESET_MASK           (0x00000040)
#define ZFM_PORTA_RFINT_MASK             (0x00000080)
#define ZFM_PORTA_RFRDY_MASK             (0x00002000)
#define ZFM_PORTA_RFCS_MASK              (0x00004000)
#define ZFM_PORTA_RFCLK_MASK             (0x00008000)
#define ZFM_PORTA_RFSOUT_MASK            (0x00010000)
#define ZFM_PORTA_RFSIN_MASK             (0x00020000)

//
//  Port B Masks
//
#define ZFM_PORTB_OLP425_INTERRUPT_MASK          (0x00040000)
#define ZFM_PORTB_OLP425_RESET_MASK              (0x00080000)
#define ZFM_PORTB_OLP425_CHIP_SELECT_MASK        (0x00100000)

//
//  Port C Masks
//
#define ZFM_PORTC_RFEN_MASK                      (0x00080000)
#define ZFM_PORTC_OLP425_POWER_ENABLE_MASK       (0x00040000)

//
//  Port D Masks
//
#define ZFM_PORTD_OLP425_CTS                     (0x00000002)
#define ZFM_PORTD_OLP425_RTS_MASK                (0x00000001)

//
//  Port E Masks
//
#define ZFM_PORTE_HCSB_MASK      (0x00000010)
#define ZFM_PORTE_HWKUP_MASK     (0x00000080)
#define ZFM_PORTE_HSTAT_MASK     (0x00000100)
#define ZFM_PORTE_HRDY_MASK      (0x00000200)
#define ZFM_PORTE_HRESET_MASK    (0x00000400)


//
//  Event Group 1 Flags
//
#define ZFM_EVENT_GROUP_1_RFRDY          (0x80000000)
#define ZFM_EVENT_GROUP_1_RFINT          (0x40000000)
#define ZFM_EVENT_GROUP_1_TELD_READY     (0x20000000)

#define ZFM_EVENT_GROUP_1_BTN_HOME       (0x00008000)
#define ZFM_EVENT_GROUP_1_BTN_SELECT     (0x00004000)
#define ZFM_EVENT_GROUP_1_BTN_UP         (0x00002000)
#define ZFM_EVENT_GROUP_1_BTN_DOWN       (0x00001000)


#define ZFM_EVENT_GROUP_1_UIM_READY      (0x00000001)

//
//
//
#define ZFM_SERIAL_NUMBER                "ZFM0000001B"
#define ZFM_MAC_ADDRESS                  0x0023F74B46000001

#define ZFM_SERIAL_NUMBER_PSC            "CN0000511X"
#define ZFM_MAC_ADDRESS_PSC              0x0023F70D62000001

#define ZFM_SERIAL_NUMBER_BGP            "BGP500202X"
#define ZFM_MAC_ADDRESS_BGP              0x0023F706AF851A2A
  
//
//
//
#endif /* ZFM_DEFINES_H_ */
